/*
Wall Worm Displacement Tools
Copyright (c) 2011 by Shawn Olson http://www.shawnolson.net

WallWorm.com



*/



fn ww_wwdt_AlignPivotTo Obj Trgt =
(
	/*Function from
	
	
	
	*/
-- Get matrix from object
if classOf Trgt != matrix3 then Trgt = Trgt.transform

-- Store child transforms
local ChldTms = in coordSys Trgt ( for Chld in Obj.children collect Chld.transform )

-- Current offset transform matrix
local TmScale = scaleMatrix Obj.objectOffsetScale
local TmRot = Obj.objectOffsetRot as matrix3
local TmPos = transMatrix Obj.objectOffsetPos
local TmOffset = TmScale * TmRot * TmPos

-- New offset transform matrix
TmOffset *= obj.transform * inverse Trgt

-- Apply matrix
Obj.transform = Trgt

-- Restore offsets
Obj.objectOffsetPos = TmOffset.translation
Obj.objectOffsetRot = TmOffset.rotation
Obj.objectOffsetScale = TmOffset.scale

-- Restore child transforms
for i = 1 to Obj.children.count do Obj.children[i].transform = ChldTms[i] * inverse Trgt * Obj.transform
)





include "config.ms"

global ww_wwdt_version = 0.7

--"dev/dev_measuregeneric01"
--global ww_wwdt_defaultMat = MultiMaterial numsubs:6 name:"nature/blendcliffgrass001a"

	
	ww_wwdt_grassBmp = openBitMap "$scripts/WallWorm.com/WallWormSimpleDisplacement/maps/nature/dirtfloor002a.tga"
	ww_wwdt_stoneBmp =  openBitMap "$scripts/WallWorm.com/WallWormSimpleDisplacement/maps/nature/cliffface002a.tga"
	
	ww_wwdt_grasstex = bitmaptexture bitmap:ww_wwdt_grassBmp filename:ww_wwdt_grassBmp.filename
	ww_wwdt_stonetex = bitmaptexture bitmap:ww_wwdt_stoneBmp filename:ww_wwdt_stoneBmp.filename
	
	ww_d9_shadermat = DirectX_9_Shader effectFilename:"$scripts/WallWorm.com/WallWormSimpleDisplacement/maps/fx/blend_dxsas.fx" name:"nature/blendcliffgrass001a" 
	ww_d9_shadermat.seteffectbitmap 1 ww_wwdt_grassBmp
	ww_d9_shadermat.seteffectbitmap 2 ww_wwdt_stoneBmp	
	
	
	global ww_wwdt_defaultMat = ww_d9_shadermat
	--ww_wwdt_defaultMat[2] = ww_d9_shadermat




-- 	
-- 	
-- 	ww_wwdt_defaultMat[2].renderMaterial = Blend name:"nature/blendcliffgrass001a" 
-- 	ww_wwdt_defaultMat[2].renderMaterial.map1.Diffuse = color 63 143 59
-- 	
-- 	ww_wwdt_defaultMat[2].renderMaterial.map1.diffuseMap = ww_wwdt_grasstex
-- 	
-- 	ww_wwdt_defaultMat[2].renderMaterial.map1.ambient = color 63 143 59
-- 	ww_wwdt_defaultMat[2].renderMaterial.map2.Diffuse = color 157 135 14
-- 	ww_wwdt_defaultMat[2].renderMaterial.map2.ambient = color 157 135 14
-- 	ww_wwdt_defaultMat[2].renderMaterial.map2.diffuseMap = ww_wwdt_stonetex
-- 	ww_wwdt_defaultMat[2].renderMaterial.mask = Vertex_Color name:"WW Displacement Blend Mask"
-- 	
-- 	ww_wwdt_defaultMat[1]=ww_wwdt_defaultMat[2]
-- 	ww_wwdt_defaultMat[3]=ww_wwdt_defaultMat[2]
-- 	ww_wwdt_defaultMat[4]=ww_wwdt_defaultMat[2]   
-- 	ww_wwdt_defaultMat[5]=ww_wwdt_defaultMat[2]
-- 	ww_wwdt_defaultMat[6]=ww_wwdt_defaultMat[2]
	
	
	
	global ww_wwdt_paint 
	global ww_wwdt_uvw 
	global ww_wwdt_poly 
	
	
	if ww_wwdt_paint == undefined do (
		ww_wwdt_paint = VertexPaint name:"WW Vertex Paint Modifier" mapChannel:-2
	)
	if ww_wwdt_uvw == undefined do (
		ww_wwdt_uvw = UVWMap name:"WW Displacement UVW" utile:1 maptype:4 vtile:1 wtile:1 channel:0 mapChannel:1
	)
	if ww_wwdt_poly == undefined do (
		ww_wwdt_poly = Edit_Poly name:"WW Displacement Poly Mod"
	)
	
if ww_wwdt_ui != undefined do (
	destroyDialog ww_wwdt_ui
)
	

function changeMode disp t= (
	
	convertto disp editable_poly
	
	addModifier disp ww_wwdt_uvw
	
	if t == "texture" then (
			addModifier disp ww_wwdt_poly
			addModifier disp ww_wwdt_paint
		) else (
				addModifier disp ww_wwdt_paint
				addModifier disp ww_wwdt_poly
		)
	
	
	)



function ww_wwdt_editMode = (
	disablesceneredraw()
	theDisp = #()				
	
	

	for disp in objects do (
			local bName = getUserProp disp "ww_wwdt_displacement_brush"
			if bName != undefined do (


				append theDisp disp
				changeMode disp "edit"
			)
		)
	
	    select theDisp
		enablesceneredraw()
		redrawviews()
	)

function ww_wwdt_paintMode = (
	disablesceneredraw()
	theDisp = #()
	for disp in objects do (
			local bName = getUserProp disp "ww_wwdt_displacement_brush"
			if bName != undefined do (
				append theDisp disp

				changeMode disp "texture"
				


			)
		)
	
		select theDisp
		enablesceneredraw()
		redrawviews()
	)

	
	function ww_wwdt_getEdgeVerts power = (
		edgeVertices = #{}
					case of (
						
						(power==2): edgeVertices = #{1..6, 10..11, 15..16, 20..31, 35..36, 40..41, 45..51, 55, 59, 63, 67, 71, 75, 79, 83, 87, 91, 95}
						(power==3): edgeVertices = #{1..10, 18..19, 27..28, 36..37, 45..46, 54..55, 63..64, 72..91, 99..100, 108..109, 117..118, 126..127, 135..136, 144..145, 153..163, 171, 179, 187, 195, 203, 211, 219, 227, 235, 243, 251, 259, 267, 275, 283, 291, 299, 307, 315, 323, 331, 339, 347, 355, 363, 371, 379}
						(power==4): edgeVertices = #{1..18, 34..35, 51..52, 68..69, 85..86, 102..103, 119..120, 136..137, 153..154, 170..171, 187..188, 204..205, 221..222, 238..239, 255..256, 272..307, 323..324, 340..341, 357..358, 374..375, 391..392, 408..409, 425..426, 442..443, 459..460, 476..477, 493..494, 510..511, 527..528, 544..545, 561..579, 595, 611, 627, 643, 659, 675, 691, 707, 723, 739, 755, 771, 787, 803, 819, 835, 851, 867, 883, 899, 915, 931, 947, 963, 979, 995, 1011, 1027, 1043, 1059, 1075, 1091, 1107, 1123, 1139, 1155, 1171, 1187, 1203, 1219, 1235, 1251, 1267, 1283, 1299, 1315, 1331, 1347, 1363, 1379, 1395, 1411, 1427, 1443, 1459, 1475, 1491, 1507, 1523}
					)
			return edgeVertices
		)
	
function ww_wwdt_sewSelected sel = (
	
	    
	disableSceneRedraw()
	
posStore = #()	
tempPosStore = #()	
brushList = #()	
		for disp in sel do (
			
		--format disp.name
		convertto disp editable_poly
			
		local brushName = getUserProp disp "ww_wwdt_displacement_brush"
		if brushName != undefined do (
		local b = getNodeByName  brushName
			

			
			if b !=undefined AND isDeleted b == false do (
				

				appendIfUnique brushList #(b,disp) 

				power = getUserProp b "ww_wwdt_power"
				
-- 				
				edgeVertices = ww_wwdt_getEdgeVerts power
					

-- 					
-- 				
-- 		
-- 		

-- 		for i in verSel do (
-- 		
-- 		addVert = false
-- 		v = polyop.getVert b i 	
-- 	
-- 			while addVert == false do ( 	
-- 				if findItem hiddenFaces start > 0 do (
-- 					addVert = true
-- 				 
-- 				 )
-- 			 )
-- 		
-- 		)
		
		
		
		
		faceStore = #{}		
				
		addDisp = true
		hiddenFaces = polyop.getHiddenFaces disp 

		for start = 1 to b.GetNumFaces()  do (
         if findItem hiddenFaces start == 0 do (
			 appendIfUnique faceStore start
			 
			 )
		
		)
		
		for f in faceStore do (
			
			verts = polyop.getFaceVerts b f

			for vert in verts do (
				if findItem edgeVertices vert > 0 do (
					--tpos = (b.GetVertex vert)
					tpos = polyop.getVert b vert
					
					if findItem tempPosStore tpos > 0 then (
					
						append posStore tpos
					) else (
						
						appendIfUnique tempPosStore tpos
					)
				
				)
			)
			
			)
				

				
				)
		)
	)
	

	ind = 1
	
	objStore = #()	
	posMap = #()
	for v in posStore do (
	
	--ind = (v as string)
	objStore[ind] = #()
		posMap[ind] = v
		for br in brushList do (

				--print (br as string)
			vertexAt = false
			
			for bv = 1 to br[1].GetNumVertices() while vertexAt==false do (
				
				--if findItem edgeVertices bv > 0 do (
				if (polyop.getVert br[1] bv) == v do (
				
					appendIfUnique objStore[ind] #(br[2],bv)
				
					vertexAt = true
				)
				)
				--)

		
		)
		
			ind+=1
		
	)
	
		for ar in objStore do (
			
				if ar.count > 1 do (
					
					avPos = [0,0,0]
					
					for s in ar do (
						
						currentPos = polyop.getVert s[1] s[2]
						--format "\nDisplacement % Vertex % Current Position %" s[1].name s[2] currentPos
						avPos = avPos + currentPos
						
						
					)
					
					avPos = avPos / ar.count
					--format "\nAverage Position %\n" avPos
					
					for s in ar do (
					currentPos = polyop.getVert s[1] s[2]
		
					--vs = polyop.getVert b i
						
						
						--currentPos = s[1].GetVertex  s[2]
						
						--dist = distance avPos currentPos
				
				--unitVector = vd/dist
						vec = (avPos-currentPos)	
						
						if dist != 0.0 do (
							
							--format "Move Displacement % Vertex % Dist  % to %\n\n" s[1].name s[2]  dist vec
							polyop.moveVert s[1] s[2] (vec) node:s[1]
								
							
						) 
						
						
					)
					
					
					
					
					)
			
			
		)
		
		
		enableSceneRedraw()
	
		messagebox "Selected Displacements Sewn"
	)
	
	
	
	

function ww_wwdt_getMinVertexOnSide side power = (
	
	vertexArrays = #()
	
	vertexArrays[2] = #()
	/*	
	vertexArrays[2][1] = #(25,5,1, (quat 1 0 0 256) , (quat 0 -1 0 256),1,16)
	vertexArrays[2][2] = #(26,30,50, (quat 1 0 0 256), (quat 0 -1 0 256),17,32)
	vertexArrays[2][3] = #(46,21,1,(quat 0 1 0 256),(quat 0 0 -1 256),81,96)
	vertexArrays[2][4] = #(30,5,25,(quat 0 1 0 256),(quat 0 0 -1 256),49,64)
	vertexArrays[2][5] = #(50,25,21,(quat 1 0 0 256),(quat 0 0 -1 256),65,80)
	vertexArrays[2][6] = #(26,1,5,(quat 1 0 0 256),(quat 0 0 -1 256),33,48)
	
		vertexArrays[2][1] = #(1,21,25, (quat 1 0 0 256) , (quat 0 -1 0 256),1,16)
	vertexArrays[2][2] = #(50,46,26, (quat 1 0 0 256), (quat 0 -1 0 256),17,32)
	vertexArrays[2][3] = #(1,26,46,(quat 0 1 0 256),(quat 0 0 -1 256),81,96)
	vertexArrays[2][4] = #(25,50,30,(quat 0 1 0 256),(quat 0 0 -1 256),49,64)
	vertexArrays[2][5] = #(21,46,50,(quat 1 0 0 256),(quat 0 0 -1 256),65,80)
	vertexArrays[2][6] = #(30,26,1,(quat 1 0 0 256),(quat 0 0 -1 256),33,48)
	
	
	*/	
	vertexArrays[2][1] = #(21,1,25, (quat 1 0 0 0) , (quat 0 -1 0 0),1,16) -- bottom
	vertexArrays[2][2] = #(26,50,30, (quat 1 0 0 0), (quat 0 -1 0 0),17,32) --top
	vertexArrays[2][3] = #(21,46,1,(quat 0 1 0 0),(quat 0 0 -1 0),81,96) -- w
	vertexArrays[2][4] = #(5,30,25,(quat 0 1 0 0),(quat 0 0 -1 0),49,64) -- e
	vertexArrays[2][5] = #(25,50,21,(quat 1 0 0 0),(quat 0 0 -1 0),65,80) -- n
	vertexArrays[2][6] = #(1,26,5,(quat 1 0 0 0),(quat 0 0 -1 0),33,48) -- s

	vertexArrays[3] = #()
	
	vertexArrays[3][1] = #(73,1,81, (quat 1 0 0 0) , (quat 0 -1 0 0),1,64) -- (1) Bottom
	vertexArrays[3][2] = #(82,162,90, (quat 1 0 0 0), (quat 0 -1 0 0),65,128) -- Top
	vertexArrays[3][3] = #(73,154,1,(quat 0 1 0 0),(quat 0 0 -1 0),321,384) -- W
	vertexArrays[3][4] = #(9,90,81,(quat 0 1 0 0),(quat 0 0 -1 0),193,256) -- E
	vertexArrays[3][5] = #(81,162,73,(quat 1 0 0 0),(quat 0 0 -1 0),257,320) -- N
	vertexArrays[3][6] = #(1,82,9,(quat 1 0 0 0),(quat 0 0 -1 0),129,192) -- S
	
	
	vertexArrays[4] = #()
	
	--vertexArrays[4][1] = #(1,273,289, (quat 1 0 0 0) , (quat 0 -1 0 0),1,256)
	--vertexArrays[4][2] = #(290,306,578, (quat 1 0 0 0), (quat 0 -1 0 0),257,512)
	--vertexArrays[4][3] = #(1,290,562,(quat 0 1 0 0),(quat 0 0 -1 0),1281,1536)
	--vertexArrays[4][4] = #(306,17,289,(quat 0 1 0 0),(quat 0 0 -1 0),769,1024)
	--vertexArrays[4][5] = #(273,562,578,(quat 1 0 0 0),(quat 0 0 -1 0),1025,1280)
	--vertexArrays[4][6] = #(17,306,290,(quat 1 0 0 0),(quat 0 0 -1 0),513,768)
	
	
	
	vertexArrays[4][1] = #(273,1,289,(quat 1 0 0 0) , (quat 0 -1 0 0),1,256) -- (1) Bottom
	vertexArrays[4][2] = #(290,578,306,(quat 1 0 0 0), (quat 0 -1 0 0),257,512) -- (2) Top
	vertexArrays[4][3] = #(273,562,1,(quat 0 1 0 0),(quat 0 0 -1 0),1281,1536) -- (6)  W
	vertexArrays[4][4] = #(17,306,289,(quat 0 1 0 0),(quat 0 0 -1 0),769,1024) -- (4) E
	vertexArrays[4][5] = #(289,578,273,(quat 1 0 0 0),(quat 0 0 -1 0),1025,1280) -- (5) N
	vertexArrays[4][6] = #(1,290,17,(quat 1 0 0 0),(quat 0 0 -1 0),513,768) -- (3) S
	
	
	
	out = vertexArrays[power][side]
	
	return out
	)	
	
	
	function ww_wwdt_offsetByEdgeVertice power side vertice = (
		

		
		
		)
	
function ww_wwdt_vmfpowertosegs p = (
	
	case of (

		(p==2): s = 4

		(p==3): s=8

		(p==4): s=16

		default: s=16

	)

	return s
	)

function ww_wwdt_getBrushValues m = (
	brushVertices = #()
-- 			case of (
-- 				(m==1): brushVertices = #(1,3,4, (quat 1 0 0 0) , (quat 0 1 0 0) )
-- 				(m==2):  brushVertices = #(8,7,5, (quat -1 0 0 0), (quat 0 1 0 0) )
-- 				(m==3): brushVertices = #(6,5,1,(quat -1 0 0 0),(quat 0 0 -1 0))
-- 				(m==4):  brushVertices = #(8,6,2,(quat 0 -1 0 0),(quat 0 0 -1 0))
-- 				(m==5): brushVertices = #(7,8,4,(quat 1 0 0 0),(quat 0 0 -1 0))	
-- 				(m==6): brushVertices = #(5,7,3,(quat 0 1 0 0),(quat 0 0 -1 0))									
-- 				default:  brushVertices = #(1,3,4,(quat 1 0 0 0),(quat 0 1 0 0))
-- 			)
	
	
				case of (
				(m==1): brushVertices = #(3,4,2, (quat 1 0 0 0) , (quat 0 -1 0 0) )
				(m==2):  brushVertices = #(5,6,8, (quat 1 0 0 0), (quat 0 -1 0 0) )
				(m==3): brushVertices = #(3,1,5,(quat 0 1 0 0),(quat 0 0 -1 0))
				(m==4):  brushVertices = #(8,6,2,(quat 0 1 0 0),(quat 0 0 -1 0))
				(m==5): brushVertices = #(4,3,7,(quat 1 0 0 0),(quat 0 0 -1 0))	
				(m==6): brushVertices = #(6,5,1,(quat 1 0 0 0),(quat 0 0 -1 0))									
				default:  brushVertices = #(3,4,2,(quat 1 0 0 0),(quat 0 -1 0 0))
			)
			return brushVertices
	)

function  ww_wwdt_makeDisplacement p l w h t pos mat = (
	segs = ww_wwdt_vmfpowertosegs p
	
	if pos == undefined do (
		
		pos=[0,0,0]
		)
	brsh = Box length:l width:w height:h isSelected:off lengthsegs:segs widthsegs:segs heightsegs:segs pos:pos	
	brsh.name =(uniqueName  "WW_Displacement_Brush_")
	modi = Smooth smoothingBits:1	
	addModifier brsh modi	
		
	convertto brsh editable_poly
		
		
	if t == "Planar" then (
		--brsh.pivot.pos[3] = (brsh.pos.z + h)
	
		
		--messagebox (brsh.pivot[3] as string)
		
		Trgt = Point pos:brsh.position

		Trgt.pos.z += h
		
		
		ww_wwdt_AlignPivotTo brsh Trgt
		
		delete Trgt
		
		
		)	
	
	disp = copy brsh
	
	channelInfo.addChannel disp
 	--channelInfo.update()
		
	convertto disp editable_poly
	
	disp.name =(uniqueName  "WW_Displacement_")
	setUserProp disp "ww_wwdt_displacement_brush" brsh.name
	setUserProp brsh "ww_wwdt_displacement" "true"
	setUserProp brsh "ww_wwdt_displacement_target" disp.name
	setUserProp brsh "ww_wwdt_power" (p as string)
	brsh.xray=on
	brsh.renderable = off
	setTransformLockFlags brsh #all
	
	
	
	hide brsh
	
	
	paramWire.connect2way disp.pos.controller[#X_Position] brsh.pos.controller[#X_Position] "X_Position" "X_Position"
	paramWire.connect2way disp.pos.controller[#Y_Position] brsh.pos.controller[#Y_Position] "Y_Position" "Y_Position"
	paramWire.connect2way disp.pos.controller[#Z_Position] brsh.pos.controller[#Z_Position] "Z_Position" "Z_Position"
	paramWire.connect2way disp.rotation.controller[#X_Rotation] brsh.rotation.controller[#X_Rotation] "X_Rotation" "X_Rotation"
	paramWire.connect2way disp.rotation.controller[#Y_Rotation] brsh.rotation.controller[#Y_Rotation] "Y_Rotation" "Y_Rotation"
	paramWire.connect2way disp.rotation.controller[#Z_Rotation] brsh.rotation.controller[#Z_Rotation] "Z_Rotation" "Z_Rotation"
	paramWire.connect2way disp.transform.controller[#Scale] brsh.transform.controller[#Scale] "Scale" "Scale"
	
	select disp
	

	
	
	 

		 
	 
	
	
	
	

	
if t == "Planar" then (
    startNum = (segs * segs)
	
startNum2 = (startNum * 2)+1
	
	
   if mat == undefined do (
  

	mat = ww_wwdt_defaultMat
	   
	--theMat[1] = groundMat
	--mat[1].opacity = 0
	--mat[3].opacity = 0
	--mat[4].opacity = 0
	--mat[5].opacity = 0
	--mat[6].opacity = 0
	   
	
	
	   )
	
	
	
	
	subobjectLevel = 4
	setCommandPanelTaskMode #modify
	disp.SetSelection #Face #{1..startNum,startNum2..disp.numfaces}
	disp.Hide #Face
	subobjectLevel = 0	
	brsh.pos.z = (brsh.pos.z - h)	
	
) else(
	--
	   
   if mat == undefined do (
  

	mat = ww_wwdt_defaultMat
	   
	--theMat[1] = groundMat

-- 	mat[3]=mat[2]
-- 	mat[4]=mat[2]   
-- 	mat[5]=mat[2]
-- 	mat[6]=mat[2]
	   
	   
-- 	if  t == "No Bottom" then (
-- 		
-- 		mat[1] = (Standard name:"invisible material")
-- 		mat[1].opacity = 0

-- 	) else (		
-- 		mat[1]=mat[2]
-- 	)
	   
	   
	   )
	   
	 
	if  t == "No Bottom" do (
		
	startNum = ((segs * segs))+1
	endNum = (startNum *2)-2


	
	subobjectLevel = 4
	setCommandPanelTaskMode #modify
	disp.SetSelection #Face #{startNum..endNum}
	disp.Hide #Face
	subobjectLevel = 0	
		
		
		)


	   
	   
	   
	)

disp.mat = mat	
	
	addModifier disp ww_wwdt_uvw
	addModifier disp ww_wwdt_paint
	addModifier disp ww_wwdt_poly
-- 	if t == "Planar" then (
-- 		ww_wwdt_makeDisplacementSide p l w h 1 brsh
-- 		) else(
-- 		
-- 		for s = 1 to 6 do (
-- 			ww_wwdt_makeDisplacementSide p l w h s brsh
-- 			)
-- 			brsh.pos.z = (brsh.pos.z + h)
-- 		)
	
	
	)	

function ww_wwdt_makeVMFDisplacement b dispo brush side = (
	local vmf = ""
			disp = copy dispo
		try(
	
		if brush==undefined do (
		
		brush = 1
		)
	
	
	
	if side==undefined do (
		
		side = 1
		)
	
	if disp.mat == undefined do (
		m = Standard name:"dev/dev_devmeasuregeneric01"

		disp.mat = m

		)
	
	oldSel = selection
	

	
		
		
		
	if b !=undefined AND isDeleted b == false do (
		
		

		
		convertto disp editable_poly
		
		--modi = Edit_Normals selectBy:1
		
		--addModifier disp modi	
		
		


		

		select disp
		setCommandPanelTaskMode #modify
		subObjectLevel = 1


		local power = getUserProp b "ww_wwdt_power"
		
		
		
		
			case of (

				(power==2): rows = 5

				(power==3): rows=9

				(power==4): rows=17

				default: rows=17

			)
			


			--local brushHelperName = getUserProp s "ww_wwdt_brush"
			
			--if brushHelperName != undefined AND brushHelperName != "" do (
				
				
			--br = getNodeByName brushHelperName			
			

			--)
		
		vmf = "solid\n"
		local l = "{\n"
		append vmf l
		l = "\"id\" \""+(brush as string)+"\"\n"
			
		append vmf l
		
	
			
	edgeVertices = ww_wwdt_getEdgeVerts power		
	for m = 1 to 6 do (
			

			--brushVertices= ww_wwdt_getBrushValues (1)
		
			brushVertices = ww_wwdt_getMinVertexOnSide m power
			sBottomLeft = polyop.getVert b brushVertices[1]
		    sTopLeft = polyop.getVert b brushVertices[2]
			sTopRight = polyop.getVert b brushVertices[3]
							
							
	
		
		ro = 0
		
-- 		if side > 2 do (
-- 			ro = 180
-- 			
-- 			)
		
		/*
		utileAmount = 1/ww_wwdt_uvw.utile
		
		vtileAmount = 1/ww_wwdt_uvw.vtile
		*/
		
		utileAmount = 1
		
		vtileAmount = 1	
		
		l = "side\n"
		append vmf l
		l = "{\n"
		append vmf l
		l = "\"id\" \""+(side as string)+"\"\n"
		append vmf l
		l = "\"plane\" \"("+(sBottomLeft[1] as string)+" "+(sBottomLeft[2] as string)+" "+(sBottomLeft[3] as string)+") ("+(sTopLeft[1] as string)+" "+(sTopLeft[2] as string)+" "+(sTopLeft[3] as string)+") ("+(sTopRight[1] as string)+" "+(sTopRight[2] as string)+" "+(sTopRight[3] as string)+")\"\n"
		append vmf l
		l = "\"material\" \""+(disp.mat.name)+"\"\n"
		append vmf l
		l="\"uaxis\" \"["+(brushVertices[4].x as string)+" "+(brushVertices[4].y as string)+" "+(brushVertices[4].z as string)+" "+(brushVertices[4].w as string)+"] "+(utileAmount as string)+"\"\n"
		append vmf l
		l="\"vaxis\" \"["+(brushVertices[5].x as string)+" "+(brushVertices[5].y as string)+" "+(brushVertices[5].z as string)+" "+(brushVertices[5].w as string)+"] "+(utileAmount as string)+"\"\n"
		append vmf l
		l = "\"rotation\" \""+(ro as string)+"\"\n"
		append vmf l
		l = "\"lightmapscale\" \"16\"\n"
		append vmf l
		l = "\"smoothing_groups\" \"0\"\n"
		append vmf l
		local norms = ""
		local dists = ""
		local offsets = ""
		local offset_normals = ""
		local alphas = ""
		local triangle_tags = ""		
		
		addDisp = true
		hiddenFaces = polyop.getHiddenFaces disp 

		for start = brushVertices[6] to brushVertices[7] while addDisp == true do (
		
		
			 if findItem hiddenFaces start > 0 do (
				 addDisp = false
				 
				 )
		
		)
		
		
		
		
		
		
		
		
		
		
	if addDisp == true do (			
		
		
		
		
		l = "dispinfo\n"
		append vmf l
		l = "{\n"
		append vmf l
		l = "\"power\" \""+(power as string)+"\"\n"
		append vmf l
		l = "\"startposition\" \"["+(sBottomLeft[1] as string)+" "+(sBottomLeft[2] as string)+" "+(sBottomLeft[3] as string)+"]\"\n"
		append vmf l
		l = "\"flags\" \"0\"\n"
		append vmf l
		l = "\"elevation\" \"0\"\n"
		append vmf l
		l = "\"subdiv\" \"0\"\n"
		append vmf l
		
		

	
	--tempM = copy d
	
	--convertto tempM editable_mesh
	
		local row = 0
		local column = 0
			
			
		local norms = "\nnormals\n{\n\"row0\" \""
		local dists = "\ndistances\n{\n\"row0\" \""
		local offsets = "\noffsets\n{\n\"row0\" \""
		local offset_normals = "\noffset_normals\n{\n\"row0\" \""
		local alphas = "\nalphas\n{\n\"row0\" \""
		local triangle_tags = "\ntriangle_tags\n{\n\"row0\" \""
	
	
	
	--get faces between  and 
	--get all vertices in this array
	--change for loop to this loop
	
	verticeStore = #()
	
	
	
	for start = brushVertices[6] to brushVertices[7] do (
		
		
		face = polyop.getFaceVerts disp start
		
		for v in face do (
			
			appendIfUnique verticeStore v
			
			)
		
		
		
		)
	
	    sort verticeStore
		
		--if bottom reverse ???
		
		for i in verticeStore do (
		
		
			vd = polyop.getVert disp i
		
			vs = polyop.getVert b i
			
			
			dist = distance vs vd
			
			--unitVector = vd/dist
			
			if dist == 0.0 then (
				unitVector = [0,0,1]
			) else (
				--unitVector =normalize (vd / dist)
				
				
				
				unitVector = normalize (vd-vs)
				
				
-- 				my_verts = #{i} --define a bitArray specifying vertex 1

-- 				my_normals = #{} --define an empty bitArray to store the result

--call the method with the two bitArrays passed by-reference: 

-- 				disp.Edit_Normals.ConvertVertexSelection &my_verts &my_normals

-- 				my_normals --now take a look at the bitArray

-- 				for thenorm in my_normals do (
-- 					
-- 					
-- 					print thenorm
-- 					
-- 					
-- 					
-- 					
-- 					)
				
				
				
				
				
-- 				if findItem edgeVertices i then (
-- 					
-- 					
-- 					) else (
-- 					
-- 						unitVector = normalize (vd-vs)
-- 					)
-- 				
				
				
				
			)
			
			
			--unitVector is not being calculated correctly for vertices shared at the edges
			--maybe because the edges have different normals?
			
			--print ("Vertex #"+(i as string)+" "+((dist) as string) +" Unit Vector: "+(unitVector as string))
			--format "Vertex # % Dist % Unit Vector: %\n" i dist unitVector 
		
		n = (unitVector[1] as string)+" "+ (unitVector[2] as string)+" "+(unitVector[3] as string)+" "
		append norms n

		dis = (dist as string)+" "
		append dists dis
			
		
		--n = "0 0 0"
		--append norms n

		--dis = "0 "
		--ppend dists dis


			
		--offset = (vs[1] as string)+" "+ (vs[2] as string)+" "+(vs[3] as string)+" "
		
		offset = "0 0 0 "

		append offsets offset
		
		
		--Fix logic here to get corners to blend in multi-sided displacements
		--if ( findItem edgeVertices i  != 0 ) then (
			
-- 		case of (
-- 			
-- 			(m==1): offsetn = "0 0 1 "
-- 			(m==2): offsetn = "0 0 1 "
-- 			(m==3): offsetn = "-1 0 0 "
-- 			(m==4): offsetn = "1 0 0 "
-- 			(m==5): offsetn = "0 1 0 "
-- 			(m==6): offsetn = "0 -1 0 "
-- 			default: offsetn = "0 0 1 "
-- 			)
					
			
			
			
			
-- 			) else (
-- 			
 			offsetn = "0 0 1 "
-- 			
-- 			)
		

		append offset_normals offsetn	
			
			
		--ac = polyop.getVDataValue d 0 i
		
			
	    --ac = (polyop.getVert d i).GetVertexColor Channel:#VertexColor

		disp.SetSelection #Vertex #{i}
		local theVertColor =disp.getVertexColor #Alpha

		a = (theVertColor.red as string)+" "
		append alphas a
			
			column+=1
			if (column == rows) do (
				
				column = 0
				row+=1
				
				n="\"\n"
				append norms n
				append dists n
				append offsets n
				append alphas n
				append offset_normals n
				if row < rows do (
					
					
				n="\"row"+(row as string)+"\" \""
				append norms n
				append dists n
				append offsets n
				append alphas n
				append offset_normals n
					)
				
				
				
				)
			
			)
	
			
				n="\n}\n"
				append norms n
				append dists n
				append offsets n
				append alphas n
				append offset_normals n
			
				append vmf norms
				append vmf dists
				append vmf offsets
				append vmf offset_normals
				append vmf alphas			
			
				--END DISPINFO
				en = "\n}\n"
				append vmf en	
		
		)
	

		--END SIDE
		en = "\n}\n"
		append vmf en	
	

						side+=1	
		)
						

						

						

			
			)
		
		
	
		
-- 		theArrs = #()
-- 		
-- 			--"uaxis" "[1 0 0 0] 0.25"
-- 			--"vaxis" "[0 -1 0 0] 0.25"
-- 		append theArrs #([1 0 0 0], [0 -1 0 0]) --bottom
-- 		append theArrs #([0 1 0 0], [0 0 -1 0]) --west
-- 		append theArrs #([0 1 0 0], [0 0 -1 0]) --east
-- 		append theArrs #([1 0 0 0], [0 0 -1 0]) --back
-- 		append theArrs #([1 0 0 0], [0 0 -1 0]) --front



		delete disp	
			

		en = "	editor\n{\n\"color\" \"0 180 133\"\n\"visgroupshown\" \"1\"\n\"visgroupautoshown\" \"1\"\n}\n}\n"
		append vmf en
		
		--print vmf
		try (
		subObjectLevel = 0
		select oldSel			
		) catch(
			print "ahhh"
			)
		)
		catch (
			
			delete disp	
			
			vmf = "//Error in Side/Displacement output"
			print vmf
			throw()
			)

		


	--delete tempM
	return vmf
)
	
function ww_wwdt_outputVMF = (
	
	clearSelection()
	disablesceneredraw()
	
	local sfn = maxFileName
	
	if sfn != undefined AND sfn != "" then (
	local mapFileName =substring  sfn 1 (sfn.count - 4)
	) else (
		
		local mapFileName = "MyMap"
		)

	include "config.ms"
	
	
	filename = getSaveFileName  caption:"Save Your VMF:" filename:(""+wwdt_mapsrc+"/"+(mapFileName as string)+".vmf") types:"VMF(*.vmf)"

--if the path exists, will result in something like:
if filename != undefined do(
	local sv = openFile filename mode:"w+"

)
	if filename == undefined OR sv == undefined then (
		
		enablesceneredraw()
		messagebox "The VMF was not saved."
		
		
		) else (
	try(

		local brush = 2
		local side = 7
		
		local gotsky = false
		
		skyname = "sky_day01_01"
		for s in objects while gotsky == false do (
			
			skyn = getUserProp s "wwsw_skyname"
			
			if skyn != undefined do (
				
				skyname=(skyn + "_hdr")
				gotsky = true
				
				)
			
			)
		
			

	
			
			
		format "\n\n//########################\n//Start Displacement Output\n\n//Generated by the Wall Worm Displacement Tool\n\n//http://www.wallworm.com\n\n"  to:sv

		
		n="versioninfo\n"
		format n to:sv
n="{\n"
		format n to:sv
	n="\"editorversion\" \"400\"\n"
		format n to:sv
	n="\"editorbuild\" \"5004\"\n"
		format n to:sv
	n="\"mapversion\" \"4\"\n"
		format n to:sv
	n="\"formatversion\" \"100\"\n"
		format n to:sv
	n="\"prefab\" \"0\"\n"
		format n to:sv
n="}\n"
		format n to:sv
n="visgroups\n"
		format n to:sv
n="{\n"
		format n to:sv
n="}\n"
		format n to:sv
n="viewsettings\n"
		format n to:sv
n="{\n"
		format n to:sv
	n="\"bSnapToGrid\" \"1\"\n"
		format n to:sv
	n="\"bShowGrid\" \"1\"\n"
		format n to:sv
	n="\"bShowLogicalGrid\" \"0\"\n"
		format n to:sv
	n="\"nGridSpacing\" \"64\"\n"
		format n to:sv
	n="\"bShow3DGrid\" \"0\"\n"
		format n to:sv
n="}\n"
		format n to:sv
n="world\n"
		format n to:sv
n="{\n"
		format n to:sv
	n="\"id\" \"1\"\n"
		format n to:sv
	n="\"mapversion\" \"4\"\n"
		format n to:sv
	n="\"classname\" \"worldspawn\"\n"
		format n to:sv
	n="\"detailmaterial\" \"detail/detailsprites\"\n"
		format n to:sv
	n="\"detailvbsp\" \"detail.vbsp\"\n"
		format n to:sv
	n="\"maxpropscreenwidth\" \"-1\"\n"
		format n to:sv
	n="\"skyname\" \""+skyname+"\"\n"
		format n to:sv

		
		
		
		for disp in objects do (
			local dispName = getUserProp disp "ww_wwdt_displacement_brush"
			if dispName != undefined do (
				s = getNodeByName  dispName
				if s !=undefined AND isDeleted s == false do (
					--convertto disp editable_poly
					n = ww_wwdt_makeVMFDisplacement s disp brush side
					format n to:sv
			
					brush+=1
					side+=6
					)
			)
		)
		
		
		
		n="\n}"
		format n to:sv
				
		
				for wwmt in shapes do (
			
					local mdl = undefined
					
					local targetlist = getUserProp wwmt "wwmt_targetslist"
					
					
					if targetlist!=undefined do (
						local targetsArray = filterString targetlist ","
					

						mdl  = getNodeByName targetsArray[1]
						if isDeleted mdl then (
							mdl=undefined
							) else(
							
								local modelPath = getUserProp wwmt "wwmt_modelPath"
								local modelName = getUserProp wwmt "wwmt_modelname"
							
							)
							
					)
											
											


		
		
		
		
		
		
		
		
		
		
		
		

	
					
							if modelPath != undefined AND modelName != undefined AND mdl !=undefined do (
						
						
						
								local propType = getUserProp wwmt "wwmt_base"
								
								local className = "prop_static"
								if propType==undefined OR propType=="" then (
									
										className = "prop_static"
									) else (
									
									className = "prop_physics"
									
									)
								
									
									local theRotation = quatToEuler mdl.rotation
						
						
	n="\n entity\n"
	format n to:sv
n="{\n"
											format n to:sv
n="\"id\" \""+(brush as string)+"\"\n"
											format n to:sv
n="\"classname\" \""+className+"\"\n"
											format n to:sv
n="\"angles\" \""+(theRotation.x as string)+" "+((theRotation.z * -1) as string)+" "+(theRotation.y as string)+"\"\n"
											format n to:sv
n="\"fademindist\" \"-1\"\n"
											format n to:sv
n="\"fadescale\" \"1\"\n"
											format n to:sv
n="\"model\" \"models/"+(modelPath as string)+"/"+(modelName as string)+".mdl\"\n"
											format n to:sv
n="\"skin\" \"0\"\n"
											format n to:sv
n="\"solid\" \"6\"\n"
											format n to:sv
n="\"origin\" \""+(mdl.pos.x as string)+" "+(mdl.pos.y as string)+" "+(mdl.pos.z as string)+"\"\n"
											format n to:sv
n="editor\n"
											format n to:sv
n="{\n"
											format n to:sv
n="\"color\" \"255 255 0\"\n"
											format n to:sv
n="\"visgroupshown\" \"1\"\n"
											format n to:sv
n="\"visgroupautoshown\" \"1\"\n"
											format n to:sv
n="\"logicalpos\" \"[0 0]\"\n"
											format n to:sv
n="}\n"
											format n to:sv
n="}\n"
											format n to:sv
			
						
						
											brush+=1
						
						)
					

			
			
			)
						
					
					
					
		enablesceneredraw()
		messagebox "The VMF File was successfully saved"
		close sv
		
		) catch (
		enablesceneredraw()
	
		messagebox "There was an error."
		print ("The error is % " +(getCurrentException() as string))
	
	
	)
) 

enablesceneredraw()
)
	

--, "Cubic", "No Bottom"
rollout ww_wwdt_ui "WW Displacements" width:212 height:626
(
	button btn_create "Create Displacement" pos:[11,256] width:192 height:34
	dropdownList ddl_creationType "Type" pos:[8,11] width:84 height:40 items:#("Planar")
	radiobuttons rdo_power "Power" pos:[97,19] width:93 height:30 labels:#("2", "3", "4") default:3 columns:3
	label lbl_version "Wall Worm Displacement Tool Version " pos:[12,420] width:143 height:27
	HyperLink wwlink "WallWorm.com" pos:[12,451] width:96 height:17 address:"http://www.wallworm.com" color:(color 0 0 255) visitedcolor:(color 0 0 255) hovercolor:(color 255 0 0)
	label lbl2 "Copyright (c) 2011 by " pos:[12,473] width:107 height:18
	HyperLink smolink "Shawn Olson" pos:[121,473] width:82 height:17 address:"http://www.shawnolson.net" color:(color 0 0 255) visitedcolor:(color 0 0 255) hovercolor:(color 255 0 0)
	button btn_vmf "Create VMF" pos:[118,357] width:89 height:34
	listbox lbx_length "Length" pos:[8,59] width:67 height:8
	dropdownList ddl_height "Height" pos:[83,145] width:117 height:40
	dropdownList ddl_width "Width" pos:[85,82] width:117 height:40 
 
 
 
 
 
 
	checkbox chk_lockWidth "Lock to Length" pos:[119,82] width:91 height:14 checked:true
	checkbox chk_lockHeight "Lock to Length" pos:[118,145] width:92 height:14 checked:true	
	
	
	
	
	
	
	spinner spn_rows "Rows" pos:[19,202] width:74 height:16 range:[1,100,1] type:#integer scale:1
	spinner spn_columns "Columns" pos:[117,202] width:88 height:16 range:[1,100,1] type:#integer scale:1
	materialButton btn_material "Default Material" pos:[11,231] width:100 height:20
	button btn_sew "Sew" pos:[9,357] width:97 height:34 toolTip:"Click here to sew the open vertices of displacements that line up next to each other. Note that this action can take a while."
	GroupBox grp1 "About WW Displacement Tool" pos:[7,400] width:200 height:102
	GroupBox grp2 "Wall Worm Shout Out" pos:[8,516] width:199 height:83
	label lbl7 "For a full-feature 3ds Max VMF Exporter, you should check out Convexity." pos:[16,534] width:185 height:49
	HyperLink cust7 "Convexity" pos:[76,576] width:122 height:17 address:"http://www.maple3d.com" color:(color 0 0 255) visitedcolor:(color 0 0 255) hovercolor:(color 255 0 0)
	checkbutton ckb_editMode "Edit" pos:[11,309] width:95 height:38 checked:true
	checkbutton ckb_texMode "Texture Mode" pos:[118,309] width:87 height:38
	spinner spn_uvwtile "Tile" pos:[135,232] width:68 height:16 range:[0.1,100,1] type:#float scale:0.05
	button btn_settings "Settings" pos:[119,450] width:85 height:13
	
	
	on btn_create pressed do
	(
			
			if rdo_power.state != 0 then (
				
				pwer = case rdo_power.state of (
	
					1: 2
	
					2: 3
	
					3: 4
				)
	
				l = (lbx_length.selected) as integer
				w = (ddl_width.selected) as integer
				h = (ddl_height.selected) as integer
	
				
				rows = spn_rows.value
				columns = spn_columns.value
				
				--row = 1
				column = 1
				pos = [0,0,0]
				for i = 1 to (rows * columns) do (
					
	-- 						if (btn_material.material != undefined) then (
	-- 							
	-- 							mat = btn_material.material
	-- 							
	-- 							) else (
	-- 							
	-- 							
	-- 							
							--)
				
						ww_wwdt_makeDisplacement pwer l w h ddl_creationType.selected pos btn_material.material
					
					    pos[1] = pos[1] +l
					
					   column+=1
					
					   if column > columns do (
						   pos[1] =0
						   pos[2]=pos[2]+w
						   column = 1
						   )
					
					)
	
				
				
				
			) else (
				
				messagebox "You must choose a power for the displacement."
				
				)
			
			)
	on btn_vmf pressed do
	(
	
	ww_wwdt_outputVMF()
		
		
	
	
	)
	on lbx_length selected sel do
	(
	
		if chk_lockWidth.checked do (
			ddl_width.selection = sel
	
		)
		if chk_lockHeight.checked do (
			ddl_height.selection = sel
	
		)
	
	)
	on btn_sew pressed do
	(
	
	
		--messagebox "picked"
	ww_wwdt_sewSelected $selection
		
		
	
		
	
	)
	on ckb_editMode changed state do
	(
		if state == true do (
			ww_wwdt_editMode()
				
			ckb_texMode.checked = false
		)
	)
	on ckb_texMode changed state do
	(
		if state == true do (
			ww_wwdt_paintMode()
			ckb_editMode.checked = false
		)
	)
	on spn_uvwtile changed val do
	(
	
	ww_wwdt_uvw.utile = val
	ww_wwdt_uvw.vtile = val
	ww_wwdt_uvw.wtile = val
	)
	on btn_settings pressed  do
	(
	
	include "wwdtconfigutility.ms"
	
	)
)
global ww_wwdt_dispsizes = #("64", "128", "256", "512", "1024", "2048", "4096")



createDialog ww_wwdt_ui

ww_wwdt_ui.lbx_length.items = ww_wwdt_dispsizes
ww_wwdt_ui.ddl_height.items = ww_wwdt_dispsizes
ww_wwdt_ui.ddl_width.items = ww_wwdt_dispsizes

ww_wwdt_ui.lbx_length.selection = 5
ww_wwdt_ui.ddl_height.selection = 5
ww_wwdt_ui.ddl_width.selection = 5

ww_wwdt_ui.spn_uvwtile.controller = ww_wwdt_uvw.utile.controller

ww_wwdt_ui.lbl_version.caption +=  (ww_wwdt_version as string)